function Rec=FraRec(C,R,L)

% function Rec=FraRec(C,R,L)
% This function implement framelet reconstruction.
% C ==== the data to be reconstructed, which are in cells in C{i,j} with
% C{1,1} being a cell.
% R ==== is the reconstruction filter in 1D. In 2D, it is generated by tensor
% product. The filter D must be symmetric or anti-symmetric, which
% are indicated by 's' and 'a' respectively in the last cell of R.
% L ==== is the level of the decomposition.
% Rec ==== is the reconstructed data.

% Written by Jian-Feng Cai.
% email: jfcai@math.cuhk.edu.hk

nR=length(R);
SorAS=R{nR};

Rec=zeros(size(C{2,2}));

for i=1:nR-1
    M1=R{i};
    for j=1:nR-1
        M2=R{j};
        temp=ConvSymAsym(C{i,j},M1,SorAS(i),L);
        temp=ConvSymAsym(temp',M2,SorAS(j),L);
        Rec=Rec+temp';
        % Rec=Rec+ConvSymAsym2D(C{i,j},M1,SorAS(i),M2,SorAS(j),L);
    end
end

% [m,n]=size(C{1,1});
% for i=1:nR-1
%     temp=[];
%     for j=1:nR-1
%         temp=[temp C{i,j}];
%     end
%     temp=ConvSymAsym(temp,R{i},SorAS(i),L);
%     for j=1:nR-1
%         tempt{i,j}=temp(:,(j-1)*n+1:j*n);
%     end
% end
% for i=1:nR-1
%     temp=[];
%     for j=1:nR-1
%         temp=[temp (tempt{j,i})'];
%     end
%     temp=ConvSymAsym(temp,R{i},SorAS(i),L);
%     for j=1:nR-1
%         tempt{j,i}=(temp(:,(j-1)*m+1:j*m))';
%     end
% end
% Rec=zeros(m,n);
% for i=1:nR-1
%     for j=1:nR-1
%         Rec=Rec+tempt{i,j};
%     end
% end
% clear tempt;